        program conv

        use constants 

        implicit none 

        !New def:
        integer :: nf, mok

        real*8, allocatable :: freq(:)
        real*8, allocatable :: nfreq(:)
        integer :: i,j,k,l,nr,nc
        real*8, allocatable :: mat(:,:)
        real*8, allocatable :: mat2(:,:)
        integer, allocatable :: con(:,:)
        real*8, allocatable :: nmat(:,:)
        real*8, allocatable :: nmat2(:,:)
        
        !Reading and defining variables:
        open (100,file='../parameters.dat', status="old")
        read(100,*) mok
        read(100,*) nf
        close(100)

        allocate(freq(nf))
        allocate(nfreq(nf))
        allocate(mat(nf,nf))
        allocate(mat2(nf,nf))
        allocate(con(nf,2))
        allocate(nmat(nf,nf))
        allocate(nmat2(nf,nf))

        !Creation of the nxn matrix from the diagonal matrix:
        
        open (100,file='../freq_vib.dat', status="old")
        do i=1, nf
        read(100,*) freq(i)
        end do
        close(100)

        open (100,file='../out.dat', status="old")
        do i=1, nf
        read(100,*) (mat(i,k), k=1, nf)
        end do
        close(100)
        
        open (100,file='../Corio_X.dat', status="old")
        do i=1, nf
        read(100,*) (mat2(i,k), k=1, nf)
        end do
        close(100)

        open (100,file='../ORDER.dat', status="old")
        do i=1, nf
        read(100,*) (con(i,k), k=1, 2)
        end do
        close(100)

        do i = 1, nf
         do j=1, nf 

              if ( i.le.j ) mat(i,j) = mat(i,j)
              if ( j.gt.i ) mat(i,j) = mat(j,i)

         enddo
        enddo

        do i = 1, nf
         do j=1, nf

              if ( i.le.j ) mat2(i,j) = mat2(i,j)
              if ( j.gt.i ) mat2(i,j) = mat2(j,i)

         enddo
        enddo
        

        do i=1, nf
         do j=1, nf
          nmat(con(i,2),con(j,2)) = mat(i,j) 
         end do 
        end do 

        do i=1, nf
         do j=1, nf
          nmat2(con(i,2),con(j,2)) = mat2(i,j)
         end do
        end do
        
        
        do i=1, nf
         nfreq(con(i,2)) = freq(i)
        end do

        open (100,file='../out.dat', status="replace")
        do i=1, nf
         write(100,*) nmat(i,:)
        end do
        close(100)

        open (100,file='../Corio_X.dat', status="replace")
        do i=1, nf
         write(100,*) nmat2(i,:)
        end do
        close(100)


        open (100,file='../newFREQ.dat', status="replace")
        do i=1, nf
         write(100,*) nfreq(i)
        end do
        close(100)       



        endprogram conv

    
