        program somma
        
        use constants        

        implicit none

        integer :: nf, mok

        integer :: i,j,im
         
        real*8, allocatable :: corio(:,:)
        real*8, allocatable :: mat(:,:)
        real*8, allocatable :: tot(:,:)
        real*8, allocatable :: freq(:)
        real*8 :: zpeA=0
        character(len=32) :: arg


        call get_command_argument(1,arg)
        select case (arg)
           case('-im')
             im=1
           case default
             im=0
        end select
        !!!Reading and defining variables:
        open (100,file='../parameters.dat', status="old")
        read(100,*) mok
        read(100,*) nf
        close(100)
        
        allocate(corio(nf,nf))
        allocate(mat(nf,nf))
        allocate(tot(nf,nf))
        allocate(freq(nf))
        !!!!

        open(unit=5, file='../Corio_X.dat', status='old')
        do i=1, nf
         read(5,*) (corio(i,j), j=1, i)
        end do
        close(5)


        open(unit=5, file='../out.dat', status='old')
        do i=1, nf
         read(5,*) (mat(i,j), j=1, nf)
        end do
        close(5)

        tot(:,:) = mat(:,:) + corio(:,:)

        open(unit=5, file='../freq_vib.dat', status='old')
        do i=1, nf
         read(5,*) freq(i)
        end do
        close(5)

        do i=1, nf
         if (i .ne. im) then
          zpeA=zpeA+0.5d0*freq(i)
         end if
         do j=1,i
          zpeA=zpeA+0.25d0*tot(i,j)
         end do
        end do


        open(unit=5, file='../X_tot.dat', status='replace')
        do i=1, nf
         write(5,*) (tot(i,j), j=1, i)
        end do
        close(5)
       
        write(*,*) zpeA        

        end program somma
