        MODULE constants
        implicit none

        real*8, parameter :: planck = 6.6261D-27 ![g cm^2 / s]
        real*8, parameter :: sol=2.99792458D10 ![cm/s]  
        real*8, parameter :: pi = DACOS(-1.d0)
        real*8, parameter :: mele = 9.1093837015D-28 ![g]
        real*8, parameter :: gtocm = 0.03335640951981521d0 !From GHz to cm^-1
        real*8, parameter :: cmtog = 29.9792458d0 !From cm^-1 to GHz
        real*8, parameter :: autoc = 219474.63068d0
        real*8, parameter :: autoA = 0.529177249d0
        real*8, parameter :: ctoau = 4.55634D-6
        real*8, parameter :: ftocm=3.33565D-11
        real*8, parameter :: hj=4.35974D-18 !Hartree to J 
        real*8, parameter :: bhm=5.29177D-11 !Bohr radius to m
        real*8, parameter :: ak=1.66054D-27


        END MODULE constants
