        program corio

        use constants 

        implicit none
       
        integer :: nf 
        !-----------------
        !integer :: nf ! Numero frequenze 
        !-----------------

        real*8, allocatable, dimension(:,:) :: lx, ly, lz
        real*8, allocatable, dimension(:,:) :: corx, cory, corz
        real*8, allocatable, dimension(:) :: eigen, freq
        real*8, allocatable, dimension(:,:) :: Xcont
        real*8, dimension(3) :: B !ROTATIONAL CONSTANTS
        integer :: i, j, k, l, a
        !-----------------
        open (100,file='parameters.dat', status="old")
        read(100,*) mok
        read(100,*) nf
        close(100)

        !nf = 3*nat - 6

        allocate(eigen(nf))
        allocate(freq(nf))
        ! From the Eckart frame calculation: 
        open(unit=5, file='Rot_const', status='old')
        do i=1, 3
          read(5,*) B(i) !Rotational constants in GHz 
        end do
        close(5)
        !Conversion back to cm => may be avoided 
        do i=1, 3
          B(i) = B(i)*gtocm
        end do
        
        !----------------------------------------------------
        open(unit=5, file='WW_vib.dat', status='old')
        do i=1, nf
        read(5,*) eigen(i)
        end do
        close(5)
        !---------------------------------------------
        !Conversion of the eigenvalues in frequencies in CM^-1
        !Modes are printed in ascending order 
        do i=1, nf
         freq(i) = dsqrt(abs(eigen(i)))*autoc           
        end do 

        open(unit=5, file='freq_vib.dat', status='replace')
         do i=1, nf
         write(5,*) freq(i)
         end do
        close(5)
        !--------------------------------------------------


        endprogram corio

