        program deriNOTENS
 
        use constants 
    
        implicit none 
        ! Number of energies in the Energy vector = points + 1 (first) 

        !New variables:
        integer :: mok, nf, points
        real*8 :: delta
        real*8 :: e ! => E eq: first value of the E vector
        real*8, allocatable :: ener(:) 
        real*8 :: der, der1, der2 
        integer :: i, j, k, l, o
        !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
        integer :: tra, fra
        integer, allocatable :: tre(:)
        integer, allocatable :: mtre(:)
        integer, allocatable :: due(:)
        integer, allocatable :: mdue(:)
        integer, allocatable :: uno(:)
        integer, allocatable :: muno(:)
        integer, allocatable :: pp(:,:)
        integer, allocatable :: pn(:,:)
        integer, allocatable :: nn(:,:)
        integer, allocatable :: ppp(:,:,:)
        integer, allocatable :: pnn(:,:,:)
        integer, allocatable :: ppn(:,:,:)
        integer, allocatable :: nnn(:,:,:)
        integer, allocatable :: tpp(:,:)
        integer, allocatable :: tpn(:,:)
        integer, allocatable :: tnp(:,:)
        integer, allocatable :: tnn(:,:)

        CHARACTER(LEN=39) :: Format
        CHARACTER(LEN=46) :: Foormat

        !Reading the new variables:
        open (100,file='../parameters.dat', status="old")
        read(100,*) mok
        read(100,*) nf
        read(100,*) points
        read(100,*) mok
        read(100,*) delta
        read(100,*) mok
        close(100)
 


        fra = nf*(nf-1)/2
        tra = nf*(nf-1)*(nf-2)/6

        !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
        allocate(ener(points))     
        !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

        allocate(tre(nf))
        allocate(mtre(nf))
        allocate(due(nf))
        allocate(mdue(nf))
        allocate(uno(nf))
        allocate(muno(nf))
        allocate(pp(nf,nf))
        allocate(nn(nf,nf))
        allocate(pn(nf,nf))
        allocate(ppp(nf,nf,nf))
        allocate(nnn(nf,nf,nf))
        allocate(ppn(nf,nf,nf))
        allocate(pnn(nf,nf,nf))
        allocate(tpp(nf,nf))
        allocate(tpn(nf,nf))
        allocate(tnp(nf,nf))
        allocate(tnn(nf,nf))
        
        
        !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
        nn(:,:) = 0
        pp(:,:) = 0
        pn(:,:) = 0
        ppp(:,:,:) = 0
        nnn(:,:,:) = 0
        ppn(:,:,:) = 0
        pnn(:,:,:) = 0
        tpp(:,:) = 0
        tpn(:,:) = 0
        tnp(:,:) = 0
        tnn(:,:) = 0
        !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! 
        !Reading Energy.tot

        open(unit=5, file='Energy.dat', status='old')
        read(5,*) e !Energy of the equilibrium geometry 
        do j=1, points !Energies from the displacements 
         read(5,*) ener(j)
        end do 
        close(5) 
        !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
        ! Definition of position of the energy in terms on the
        ! displacement tensor 
        
        i = 1

        do j=1, nf
         tre(j) = i
         i=i+1
         due(j) = i
         i=i+1
         uno(j) = i
         i=i+1
         muno(j) = i
         i=i+1
         mdue(j) = i
         i=i+1
         mtre(j) = i
         i=i+1
        end do
        do j=1, nf !N(N-1)/2
         do k=1, j
          if (j .ne. k) then
          pp(j,k) = i !Positional matrix in geonv
          pp(k,j) = i 
          i = i + 1
          end if
         end do
        end do
        do j=1, nf
         do k=1, nf
          if (j .ne. k) then ! N(N-1)
          pn(j,k) = i
          i = i + 1
          end if
         end do
        end do
        do j=1, nf
         do k=1, j
          if (j .ne. k) then ! N(N-1)/2
          nn(j,k) = i
          nn(k,j) = i
          i = i + 1
          end if
         end do
        end do
        do j=1, nf ! N(N-1)(N-2)/6
         do k=1, j
          do l=1, k
           if ((j .ne. k) .and. (l .ne. k)) then
           ppp(j,k,l) = i
           ppp(k,l,j) = i 
           ppp(k,j,l) = i
           ppp(j,l,k) = i
           ppp(l,k,j) = i
           ppp(l,j,k) = i
           i = i + 1
           end if
          end do
         end do
        end do
        do j=1, nf ! N(N-1)(N-2)/2
         do k=1, j
          do l=1, nf
           if ((j .ne. k) .and. (l .ne. k) .and. (l .ne. j)) then
           ppn(j,k,l) = i
           ppn(k,j,l) = i
           i = i + 1
           end if
          end do
         end do
        end do
        do j=1, nf ! N(N-1)(N-2)/2
         do k=1, nf
          do l=1, k
           if ((j .ne. k) .and. (l .ne. k) .and. (l .ne. j)) then
           pnn(j,k,l) = i
           pnn(j,l,k) = i
           i = i + 1
           end if
          end do
         end do
        end do
        do j=1, nf ! N(N-1)(N-2)/6
         do k=1, j
          do l=1, k
           if ((j .ne. k) .and. (l .ne. k)) then
           nnn(j,k,l) = i
           nnn(j,l,k) = i
           nnn(k,j,l) = i
           nnn(k,l,j) = i
           nnn(l,k,j) = i
           nnn(l,j,k) = i
           i = i + 1
           end if
          end do
         end do
        end do

        do j=1, nf ! N(N-1)
         do k=1, nf
          if (j .ne. k) then
          tpp(j,k) = i
          i = i + 1
          end if
         end do
        end do
        do j=1, nf ! N(N-1)
         do k=1, nf
          if (j .ne. k) then
          tpn(j,k) = i
          i = i + 1
          end if
         end do
        end do
        do j=1, nf ! N(N-1)
         do k=1, nf
          if (j .ne. k) then
          tnn(j,k) = i
          i = i + 1
          end if
         end do
        end do
        do j=1, nf ! N(N-1)
         do k=1, nf
          if (j .ne. k) then
          tnp(j,k) = i
          i = i + 1
          end if
         end do
        end do

        !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
        !FORMAT:
        Format = "(I4'd0', I4'd0', I4'd0', ' ', ES14.7)"
        Foormat = "(I4'd0', I4'd0', I4'd0', I4'd0', ' ', ES14.7)"
        !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
        ! Third der calculation
        open(unit=5, file='derter', status='replace')
        do i=1, nf 
         do j=1, i 
          do k=1, j
          if ((i .eq. j) .and. (j .eq. k)) then
           ! Eq iii
           der=(1.d0/(8.d0*(delta**3)))*(8.d0*ener(due(i))+ &
              &13.d0*ener(muno(i))+ener(mtre(i))-ener(tre(i))- & 
              &8.d0*ener(mdue(i))-13.d0*ener(uno(i)))
           write(5,Format) i,j,k,der*autoc
          else if (j .eq. k) then 
          ! j,k,i = j,j,i
           der=(1.d0/(2.d0*(delta**3)))*((ener(pp(j,i))-ener(pn(j,i)))+&
              &(ener(pn(i,j))-ener(nn(j,i)))+(2.d0*ener(muno(i))-&
              &2.d0*ener(uno(i))))
           write(5,Format) j,k,i,der*autoc
          else if (i .eq. j) then 
           der=(1.d0/(2.d0*(delta**3)))*((ener(pp(i,k))-ener(pn(i,k)))+&
              &(ener(pn(k,i))-ener(nn(i,k)))+(2.d0*ener(muno(k))-&
              &2.d0*ener(uno(k)))) 
           write(5,Format) i, j, k, der*autoc
         

          else
           der=(1.d0/(8.d0*(delta**3)))*(ener(ppp(i,j,k))-&
              &ener(ppn(j,k,i))-ener(ppn(i,k,j))-ener(ppn(i,j,k))+&
              &ener(pnn(i,j,k))+ener(pnn(k,i,j))+ener(pnn(j,i,k))-&
              &ener(nnn(i,j,k)))
           write(5,Format) i, j, k, der*autoc
          end if 
          end do 
         end do 
        end do 
        close(5) 
        
        !Fourth order der:

        open(unit=5, file='derqua', status='replace')
        do i=1, nf
         do o=1, i
          do j=1, o
           do k=1, j
           if ((i .eq. o) .and. (j .eq. o) .and. (k .eq. j)) then   
           ! iiii
            der=(1.d0/(6.d0*(delta**4)))*(-ener(tre(i))+&
                 &12.0*ener(due(i))-39.d0*ener(uno(i))+56.d0*e-&
                 &39.d0*ener(muno(i))+12.d0*ener(mdue(i))-ener(mtre(i)))
            write(5,Foormat) i, o, j, k, der*autoc    
           else if ((i .eq. o) .and. (j .eq. o)) then 
           ! iiik 
            der=(1.d0/(16.d0*(delta**4)))*((ener(tpp(i,k))-&
               &3.d0*ener(pp(i,k))+3.d0*ener(pn(k,i))-ener(tnp(i,k)))-&
               &(ener(tpn(i,k))-3.d0*ener(pn(i,k))+3.d0*ener(nn(i,k))-&
               &ener(tnn(i,k))))
            write(5,Foormat) i, o, j, k, der*autoc
           else if ((j .eq. o) .and. (k .eq. j)) then 
           ! ijjj
            der=(1.d0/(16.d0*(delta**4)))*((ener(tpp(k,i))-&
               &3.d0*ener(pp(i,k))+3.d0*ener(pn(i,k))-ener(tnp(k,i)))-&
               &(ener(tpn(k,i))-3.d0*ener(pn(k,i))+3.d0*ener(nn(i,k))-&
               &ener(tnn(k,i))))
            write(5,Foormat) o, j, k, i, der*autoc
           else if ((i .eq. o) .and. (k .eq. j)) then 
           ! iijj
            der=(1.d0/(delta**4))*((ener(pp(i,j))+ener(pn(j,i))+&
               &ener(pn(i,j))+ener(nn(i,j)))-2.d0*(ener(uno(i))+&
               &ener(muno(i))+ener(uno(j))+ener(muno(j)))+4.d0*e)  
            write(5,Foormat) i, o, j, k, der*autoc 
           else if (i .eq. o) then  
           ! iijk
            der=(1.d0/(4.d0*(delta**4)))*((ener(ppp(i,j,k))-&
               &ener(ppn(i,k,j))-ener(ppn(i,j,k))+ener(pnn(i,j,k))+&
               &ener(ppn(j,k,i))-ener(pnn(k,i,j))-ener(pnn(j,i,k))+&
               &ener(nnn(i,j,k)))-2.d0*(ener(pp(j,k))-ener(pn(k,j))-&
               &ener(pn(j,k))+ener(nn(j,k)))) 
            write(5,Foormat) i, o, j, k, der*autoc 
           else if (j .eq. k) then 
           ! iokk 
            der=(1.d0/(4.d0*(delta**4)))*((ener(ppp(i,o,k))-&
               &ener(ppn(k,o,i))-ener(ppn(k,i,o))+ener(pnn(k,i,o))+&
               &ener(ppn(o,i,k))-ener(pnn(o,i,k))-ener(pnn(i,o,k))+&
               &ener(nnn(i,o,k)))-2.d0*(ener(pp(i,o))-ener(pn(o,i))-&
               &ener(pn(i,o))+ener(nn(i,o))))
            write(5,Foormat) i, o, j, k, der*autoc
           end if 
           end do 
          end do 
         end do 
        end do 
        close(5)
                
                
        endprogram 
