        subroutine units( T, n, Q, m, H, l )
        ! Funzione per convertire in au e viceversa i vettori in input 
        ! Converts to au and viceversa input and output vectors
        use constants 

        implicit none 

        integer :: i, j, k
        integer :: n, m, l      
   
        real*8, intent(inout) :: T(n,4) !Third order
        real*8, intent(inout) :: Q(m,5) !Fourth order
        real*8, intent(inout) :: H(l)   !Freq
        !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
        T(:,4) = T(:,4)*ctoau
        Q(:,5) = Q(:,5)*ctoau
        H(:) = H(:)*ctoau 
                
        ! Rescaling of the derivatives
        
        do i=1, n
         T(i,4) = T(i,4)*sqrt(H(nint(T(i,1)))*H(nint(T(i,2)))*&
         &H(nint(T(i,3)))) 
        end do
        do i=1, m
         Q(i,5) = Q(i,5)*sqrt(H(nint(Q(i,1)))*H(nint(Q(i,2)))*&
         &H(nint(Q(i,3)))*H(nint(Q(i,4))))
        end do
        
        


        end subroutine         
