        program mainTS
        implicit none 

        integer i, j, n, m, l, iost
        integer :: sa, sb
        integer, parameter :: im = 1
        integer, parameter :: p = 50
        REAL*8, ALLOCATABLE :: TEMP(:,:)
        real*8, allocatable :: ter(:,:)
        real*8, allocatable :: quar(:,:)
        real*8, allocatable :: fre(:)
        real*8, allocatable :: Ra(:,:), Rb(:,:)
        real*8, allocatable :: chi(:,:)
        open (100,file='derter', status="old")    
        !Dimension of ter.
        iost=0
        n=0
        do  
         read(100, *, IOSTAT = iost)
          if (iost < 0) exit
           n = n + 1
        end do      
        allocate(ter(n,4))
        rewind(100)
        !Reading TER:      
        do i=1, n
         read(100,*) ter(i,1), ter(i,2), ter(i,3), ter(i,4)  
        end do

        close(100)
        
        open (100,file='derqua', status="old")
        !Dimension of quar.
        iost=0
        m=0
        do
         read(100, *, IOSTAT = iost)
          if (iost < 0) exit
           m = m + 1
        end do
        allocate(quar(m,5))
        rewind(100)
        !Reading quar:      
        do i=1, m
         read(100,*) quar(i,1), quar(i,2), quar(i,3), quar(i,4), &
         &quar(i,5)
        end do
        close(100)
        
        !Reading freq: 
        open (100,file='../freq_vib.dat', status="old")
        !Dimension of freq
        iost=0
        l=0
        do
         read(100, *, IOSTAT = iost)
          if (iost < 0) exit
           l = l + 1
        end do
        allocate(fre(l))
        rewind(100)
        !Reading freq:      
        do i=1, l
         read(100,*) fre(i)
        end do
        close(100)
        
        allocate(chi(l,l))
        
        allocate(Ra(p,4))
        allocate(Rb(p,4))
        call resonanceTS( ter, fre, n, l, p, Ra, Rb, sa, sb, im )
        
       ALLOCATE(TEMP(P,4))
       TEMP(:,:) = Ra(:,:)
       DEALLOCATE(Ra)
       ALLOCATE(Ra(sa,4))
       DO I=1, sa
       Ra(I,:) = TEMP(I,:)         
       END DO 
       DEALLOCATE(TEMP)

       ALLOCATE(TEMP(P,4))
       TEMP(:,:) = Rb(:,:)
       DEALLOCATE(Rb)
       ALLOCATE(Rb(sb,4))
       DO I=1, sb
       Rb(I,:) = TEMP(I,:)
       END DO
       DEALLOCATE(TEMP)

        open (100,file='riso.dat', status="replace")
        do i=1, sa
         write(100,*) Ra(i,:)
        end do 
        close(100)
        open (100,file='riso2.dat', status="replace")
        do i=1, sb 
         write(100,*) Rb(i,:)
        end do
        close(100)
        
        call units( ter, n, quar, m, fre, l )

        call vpt2ts(ter, n, quar, m, fre, l, Ra, sa, Rb, sb, chi, im) 
        
        call units2( chi, l )
        
        open (100,file='../out.dat', status="replace")
        do i=1, l
         write(100,*) chi(i,:)
        end do
        close(100)

        end program mainTS



